Move lcm certificate to lcm folder in OSM helm chart
[osm/devops.git] / installers / install_juju.sh
1 #!/bin/bash
2 #
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at
6 #
7 # http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14 #
15
16 function usage(){
17 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
18 echo -e "usage: $0 [OPTIONS]"
19 echo -e "Install Juju for OSM"
20 echo -e " OPTIONS"
21 echo -e " -h / --help: print this help"
22 echo -e " -D <devops path> use local devops installation path"
23 echo -e " -s <stack name> or <namespace> user defined stack name when installed using swarm or namespace when installed using k8s, default is osm"
24 echo -e " -H <VCA host> use specific juju host controller IP"
25 echo -e " -S <VCA secret> use VCA/juju secret key"
26 echo -e " -P <VCA pubkey> use VCA/juju public key file"
27 echo -e " -l: LXD cloud yaml file"
28 echo -e " -L: LXD credentials yaml file"
29 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
30 echo -e " --debug: debug mode"
31 echo -e " --cachelxdimages: cache local lxd images, create cronjob for that cache (will make installation longer)"
32 echo -e " --nojuju: do not juju, assumes already installed"
33 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
34 }
35
36 function update_juju_images(){
37 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
38 crontab -l | grep update-juju-lxc-images || (crontab -l 2>/dev/null; echo "0 4 * * 6 $USER ${OSM_DEVOPS}/installers/update-juju-lxc-images --xenial --bionic") | crontab -
39 ${OSM_DEVOPS}/installers/update-juju-lxc-images --xenial --bionic
40 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
41 }
42
43 function install_juju() {
44 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
45 echo "Installing juju"
46 sudo snap install juju --classic --channel=$JUJU_VERSION/stable
47 [[ ":$PATH": != *":/snap/bin:"* ]] && PATH="/snap/bin:${PATH}"
48 [ -n "$INSTALL_CACHELXDIMAGES" ] && update_juju_images
49 echo "Finished installation of juju"
50 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
51 return 0
52 }
53
54 function juju_createcontroller_k8s(){
55 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
56 cat $HOME/.kube/config | juju add-k8s $OSM_VCA_K8S_CLOUDNAME --client \
57 || FATAL "Failed to add K8s endpoint and credential for client in cloud $OSM_VCA_K8S_CLOUDNAME"
58 juju bootstrap -v --debug $OSM_VCA_K8S_CLOUDNAME $OSM_STACK_NAME \
59 --config controller-service-type=loadbalancer \
60 --agent-version=$JUJU_AGENT_VERSION \
61 || FATAL "Failed to bootstrap controller $OSM_STACK_NAME in cloud $OSM_VCA_K8S_CLOUDNAME"
62 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
63 }
64
65 function juju_addlxd_cloud(){
66 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
67 mkdir -p /tmp/.osm
68 OSM_VCA_CLOUDNAME="lxd-cloud"
69 LXDENDPOINT=$DEFAULT_IP
70 LXD_CLOUD=/tmp/.osm/lxd-cloud.yaml
71 LXD_CREDENTIALS=/tmp/.osm/lxd-credentials.yaml
72
73 cat << EOF > $LXD_CLOUD
74 clouds:
75 $OSM_VCA_CLOUDNAME:
76 type: lxd
77 auth-types: [certificate]
78 endpoint: "https://$LXDENDPOINT:8443"
79 config:
80 ssl-hostname-verification: false
81 EOF
82 openssl req -nodes -new -x509 -keyout /tmp/.osm/client.key -out /tmp/.osm/client.crt -days 365 -subj "/C=FR/ST=Nice/L=Nice/O=ETSI/OU=OSM/CN=osm.etsi.org"
83 cat << EOF > $LXD_CREDENTIALS
84 credentials:
85 $OSM_VCA_CLOUDNAME:
86 lxd-cloud:
87 auth-type: certificate
88 server-cert: /var/snap/lxd/common/lxd/server.crt
89 client-cert: /tmp/.osm/client.crt
90 client-key: /tmp/.osm/client.key
91 EOF
92 lxc config trust add local: /tmp/.osm/client.crt
93 juju add-cloud -c $OSM_STACK_NAME $OSM_VCA_CLOUDNAME $LXD_CLOUD --force
94 juju add-credential -c $OSM_STACK_NAME $OSM_VCA_CLOUDNAME -f $LXD_CREDENTIALS
95 sg lxd -c "lxd waitready"
96 juju controller-config features=[k8s-operators]
97 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
98 }
99
100 #Safe unattended install of iptables-persistent
101 function check_install_iptables_persistent(){
102 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
103 echo -e "\nChecking required packages: iptables-persistent"
104 if ! dpkg -l iptables-persistent &>/dev/null; then
105 echo -e " Not installed.\nInstalling iptables-persistent requires root privileges"
106 echo iptables-persistent iptables-persistent/autosave_v4 boolean true | sudo debconf-set-selections
107 echo iptables-persistent iptables-persistent/autosave_v6 boolean true | sudo debconf-set-selections
108 sudo apt-get -yq install iptables-persistent
109 fi
110 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
111 }
112
113 function juju_createproxy() {
114 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
115 check_install_iptables_persistent
116
117 if ! sudo iptables -t nat -C PREROUTING -p tcp -m tcp -d $DEFAULT_IP --dport 17070 -j DNAT --to-destination $OSM_VCA_HOST; then
118 sudo iptables -t nat -A PREROUTING -p tcp -m tcp -d $DEFAULT_IP --dport 17070 -j DNAT --to-destination $OSM_VCA_HOST
119 sudo netfilter-persistent save
120 fi
121 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
122 }
123
124 DEBUG_INSTALL=""
125 INSTALL_CACHELXDIMAGES=""
126 INSTALL_NOJUJU=""
127 JUJU_AGENT_VERSION=2.9.29
128 JUJU_VERSION=2.9
129 OSM_DEVOPS=
130 OSM_STACK_NAME=osm
131 OSM_VCA_HOST=
132 OSM_VCA_CLOUDNAME="localhost"
133 OSM_VCA_K8S_CLOUDNAME="k8scloud"
134 RE_CHECK='^[a-z0-9]([-a-z0-9]*[a-z0-9])?$'
135
136 while getopts ":D:i:s:H:l:L:K:-: h" o; do
137 case "${o}" in
138 D)
139 OSM_DEVOPS="${OPTARG}"
140 ;;
141 i)
142 DEFAULT_IP="${OPTARG}"
143 ;;
144 s)
145 OSM_STACK_NAME="${OPTARG}" && [[ ! "${OPTARG}" =~ $RE_CHECK ]] && echo "Namespace $OPTARG is invalid. Regex used for validation is $RE_CHECK" && exit 0
146 ;;
147 H)
148 OSM_VCA_HOST="${OPTARG}"
149 ;;
150 l)
151 LXD_CLOUD_FILE="${OPTARG}"
152 ;;
153 L)
154 LXD_CRED_FILE="${OPTARG}"
155 ;;
156 K)
157 CONTROLLER_NAME="${OPTARG}"
158 ;;
159 -)
160 [ "${OPTARG}" == "help" ] && usage && exit 0
161 [ "${OPTARG}" == "debug" ] && DEBUG_INSTALL="--debug" && continue
162 [ "${OPTARG}" == "nojuju" ] && INSTALL_NOJUJU="y" && continue
163 [ "${OPTARG}" == "cachelxdimages" ] && INSTALL_CACHELXDIMAGES="y" && continue
164 echo -e "Invalid option: '--$OPTARG'\n" >&2
165 usage && exit 1
166 ;;
167 :)
168 echo "Option -$OPTARG requires an argument" >&2
169 usage && exit 1
170 ;;
171 \?)
172 echo -e "Invalid option: '-$OPTARG'\n" >&2
173 usage && exit 1
174 ;;
175 h)
176 usage && exit 0
177 ;;
178 *)
179 usage && exit 1
180 ;;
181 esac
182 done
183
184 source $OSM_DEVOPS/common/logging
185 source $OSM_DEVOPS/common/track
186
187 echo "DEBUG_INSTALL=$DEBUG_INSTALL"
188 echo "DEFAULT_IP=$DEFAULT_IP"
189 echo "OSM_DEVOPS=$OSM_DEVOPS"
190 echo "HOME=$HOME"
191
192 [ -z "$INSTALL_NOJUJU" ] && install_juju
193 track juju juju_install_ok
194
195 if [ -z "$OSM_VCA_HOST" ]; then
196 if [ -z "$CONTROLLER_NAME" ]; then
197 juju_createcontroller_k8s
198 juju_addlxd_cloud
199 if [ -n "$LXD_CLOUD_FILE" ]; then
200 [ -z "$LXD_CRED_FILE" ] && FATAL "The installer needs the LXD credential yaml if the LXD is external"
201 OSM_VCA_CLOUDNAME="lxd-cloud"
202 juju add-cloud $OSM_VCA_CLOUDNAME $LXD_CLOUD_FILE --force || juju update-cloud $OSM_VCA_CLOUDNAME --client -f $LXD_CLOUD_FILE
203 juju add-credential $OSM_VCA_CLOUDNAME -f $LXD_CRED_FILE || juju update-credential $OSM_VCA_CLOUDNAME lxd-cloud-creds -f $LXD_CRED_FILE
204 fi
205 juju_createproxy
206 else
207 OSM_VCA_CLOUDNAME="lxd-cloud"
208 if [ -n "$LXD_CLOUD_FILE" ]; then
209 [ -z "$LXD_CRED_FILE" ] && FATAL "The installer needs the LXD credential yaml if the LXD is external"
210 juju add-cloud -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME $LXD_CLOUD_FILE --force || juju update-cloud lxd-cloud -c $CONTROLLER_NAME -f $LXD_CLOUD_FILE
211 juju add-credential -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME -f $LXD_CRED_FILE || juju update-credential lxd-cloud -c $CONTROLLER_NAME -f $LXD_CRED_FILE
212 else
213 mkdir -p ~/.osm
214 cat << EOF > ~/.osm/lxd-cloud.yaml
215 clouds:
216 lxd-cloud:
217 type: lxd
218 auth-types: [certificate]
219 endpoint: "https://$DEFAULT_IP:8443"
220 config:
221 ssl-hostname-verification: false
222 EOF
223 openssl req -nodes -new -x509 -keyout ~/.osm/client.key -out ~/.osm/client.crt -days 365 -subj "/C=FR/ST=Nice/L=Nice/O=ETSI/OU=OSM/CN=osm.etsi.org"
224 local server_cert=`cat /var/snap/lxd/common/lxd/server.crt | sed 's/^/ /'`
225 local client_cert=`cat ~/.osm/client.crt | sed 's/^/ /'`
226 local client_key=`cat ~/.osm/client.key | sed 's/^/ /'`
227 cat << EOF > ~/.osm/lxd-credentials.yaml
228 credentials:
229 lxd-cloud:
230 lxd-cloud:
231 auth-type: certificate
232 server-cert: |
233 $server_cert
234 client-cert: |
235 $client_cert
236 client-key: |
237 $client_key
238 EOF
239 lxc config trust add local: ~/.osm/client.crt
240 juju add-cloud -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME ~/.osm/lxd-cloud.yaml --force || juju update-cloud lxd-cloud -c $CONTROLLER_NAME -f ~/.osm/lxd-cloud.yaml
241 juju add-credential -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME -f ~/.osm/lxd-credentials.yaml || juju update-credential lxd-cloud -c $CONTROLLER_NAME -f ~/.osm/lxd-credentials.yaml
242 fi
243 fi
244 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`sg lxd -c "juju show-controller $OSM_STACK_NAME"|grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
245 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`juju show-controller $CONTROLLER_NAME |grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
246 [ -z "$OSM_VCA_HOST" ] && FATAL "Cannot obtain juju controller IP address"
247 fi
248 track juju juju_controller_ok
249
250